#ifndef __HX8363_Init_H__
#define __HX8363_Init_H__
//============================================================================
//
// SPI to RGB initiaize routine for CFAF480640 / HX8363
//
// 2019-12-06 Crystalfontz America, Inc. / Brent A. Crosby
//===========================================================================
//This is free and unencumbered software released into the public domain.
//
//Anyone is free to copy, modify, publish, use, compile, sell, or
//distribute this software, either in source code form or as a compiled
//binary, for any purpose, commercial or non-commercial, and by any
//means.
//
//In jurisdictions that recognize copyright laws, the author or authors
//of this software dedicate any and all copyright interest in the
//software to the public domain. We make this dedication for the benefit
//of the public at large and to the detriment of our heirs and
//successors. We intend this dedication to be an overt act of
//relinquishment in perpetuity of all present and future rights to this
//software under copyright law.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
//OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
//ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//OTHER DEALINGS IN THE SOFTWARE.
//
//For more information, please refer to <http://unlicense.org/>
//============================================================================

//Arduino style pin defines

//Debug LED, or used for scope triggeer or timing
#define DEBUG_LED   (3)

#define DISP_CS_NOT    (5)
#define DISP_RST_NOT   (6)
#define SCK   (13)
#define MOSI   (11)


//Faster direct port access
#define CLR_MOSI              (PORTB &= ~(0x08))
#define SET_MOSI              (PORTB |=  (0x08))
#define CLR_MISO              (PORTB &= ~(0x10))
#define SET_MISO              (PORTB |=  (0x10))
#define CLR_SCK               (PORTB &= ~(0x20))
#define SET_SCK               (PORTB |=  (0x20))

//Hack for CFAF480640 / HX8363
#define CLR_DISP_CS           (PORTD &= ~(0x20))
#define SET_DISP_CS           (PORTD |=  (0x20))
#define CLR_DISP_RST          (PORTD &= ~(0x40))
#define SET_DISP_RST          (PORTD |=  (0x40))

#define CLR_DEBUG_LED         (PORTD &= ~(0x08))
#define SET_DEBUG_LED         (PORTD |=  (0x08))



//============================================================================
void SerPrintFF(const __FlashStringHelper *fmt, ... );
void HX8363_LCD_Init(void);
//============================================================================
#endif // __HX8363_Init_H__
